/*
Copyright 2009 Marcio Bueno Licensed under the
Educational Community License, Version 2.0 (the "License"); you may
not use this file except in compliance with the License. You may
obtain a copy of the License at

http://www.osedu.org/licenses/ECL-2.0

Unless required by applicable law or agreed to in writing,
software distributed under the License is distributed on an "AS IS"
BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
or implied. See the License for the specific language governing
permissions and limitations under the License.
*/

#include <iostream>
#include "Fila.h"

using namespace std;

// programa que testa a Fila genrica uma Fila de Inteiros
int main()
{
	cout << "Fila de INTEIROS" << endl;
	Fila<int> *f1 = new Fila<int>();
	f1->inserir(5);
	f1->inserir(15);
	f1->inserir(8);
	f1->inserir(3);
	cout << "Inicio = " << f1->primeiro() << endl
		 << "Fim = " << f1->ultimo() << endl
		 << "Fila 1 = " << (*f1);
	cout << endl << "Removido o incio da fila: " << f1->remover() << endl;
	cout << endl<< "Inicio = " << f1->primeiro() << endl
		 << "Fim = " << f1->ultimo() << endl << endl;
	delete f1;
	f1 = NULL;

	// programa que testa a Fila genrica uma Fila de Caracteres declarada como ponteiro
	cout << "Fila de CARACTERES" << endl;
	Fila<char> f2;
	f2 += 'a'; // utilizando o operador += que foi redefinido
	f2 += 'z'; // ao invs de utilizar o mtodo inserir
	f2 += 'f';
	f2 += 'h';
	cout << "Inicio = " << f2.primeiro() << endl
		 << "Fim = " << f2.ultimo() << endl
		 << "Fila 2 = " << f2;
	cout << endl << "Removido o incio da fila: " << f2.remover() << endl;
	cout << endl << "Inicio = " << f2.primeiro() << endl
		 << "Fim = " << f2.ultimo() << endl << endl;
}